<?php 
require ("lib-abdesk.php");
CheckCookie();
?>
<html><head><title>ABDesktop Uncommonly-Used Functions</title></html>
<link rel=stylesheet href="css/Main.css" type="text/css"></head>
<body>
<center>
<?php AllOrganizerNavLinks();
?>
<p>
<h1>Uncommonly-Used Functions</h1>
<p>
<div class='navanchs'><a href="#all">All Organizers</a> - <a href="#links">URL Organizer</a> - <a href="#ideas">Idea Organizer</a> - <a href="#files">File Organizer</a> - <a href="#broken">Broken Stuff</a></div>
<p>
Here you'll find various functions you probably won't be using that often.  Not all of these links will work if you moved the "abdesk-dangerous" folder somewhere else.
<p>
Not all of the things in that folder are definitely dangerous, but, since they use a MySQL user with global privileges, even the probably not-so-dangerous ones might in fact be dangerous somehow.
<p>
Here's a page with <b><a href="abdesk-dangerous/01dangerous.php">Dangerous Functions</a></b>.
<p>
I recommend making backups of your databases before you do anything major with them.  This can be done by saving a copy of your databases' folders located in <code>C:\xampp\mysql\data</code>, along with a backup copy of <code>C:\xampp\htdocs\abdesk-data</code>. (That's the folder which contains thumbnails and file browsers created by the Astroblahhh File Organizer, and any databases exported using a script like the Export Ideas DB script).
<p>
<br>
<a name="all"></a>
<hr width=25%>
<p>
<center><h2>All Organizers</h2>
<p>
<a href="abdesk-dangerous/create_dbs_and_user_form.php" class="arlink">Create All ABDesktop Databases and MySQL User</a> - This uses your root MySQL account (with global privileges) to do things, and it lets you create MySQL users with lousy passwords, and probably lets you create user names or passwords which have characters MySQL dislikes.  Hopefully it can't possibly overwrite existing databases, but, be careful.
<p>
<a href="abdesk-dangerous/create_user_form.php" class='arlink'>Create MySQL User For ABDesktop</a> - for users upgrading to Astroblahhh Desktop v1.0 from a previous version.  This also uses your root MySQL account with global privileges.
<p>
<a href="abdesk-dangerous/create_db_form.php" class="arlink">Create ABDesktop Database</a> - This uses your root MySQL account (with global privileges) to create a new database of the name and type you specify. It will also create a new DB user if the user you input doesn't already exist; or, if the user does exist, the user is given privileges for the new database.  Hopefully it can't possibly overwrite existing databases, but, be careful.
<p>
<a href="abdesk-dangerous/create_multi_dbs_form.php" class="arlink">Create Multiple ABDesktop Databases</a> - This uses your root MySQL account (with global privileges) to create a new database of the name and type you specify. It will also create a new DB user if the user you input doesn't already exist; or, if the user does exist, the user is given privileges for the new database.  Hopefully it can't possibly overwrite existing databases, but, be careful.
<p>
<a href="logout.php" class="arlink">Logout</a>
<p>
<a name="links"></a><a name="url_organizer"></a>
<hr width=25%>
<p>
<center><h2>URL Organizer</h2>
<p>

<a href="urls/update_urls_tags_form.php" class="arlink">Update Links Tags</a> - This was made so the exported links I imported into my main database would have their tags made searchable by adding them to the tagmap and tags tables.  Hopefully not dangerous, but I wouldn't run it unless you really need to.  You shouldn't need to unless a) you either exported an ideas database that you just merged into another database, in which case you'll need to run this in order to have searchable tags on the imported items, or b) you're altering ABDesktop's code and messed up your database's tags somehow, or c) there are some tag glitches I still don't know about.
<p>
<a href="urls/update_col_dates_form.php" class="arlink">Update Links' Earliest Dates of Collection</a> - This will only be useful with databases created with versions of Astroblahhh Desktop prior to v1.0.  It just goes through the dates of collection table, gets the earliest date for each URL, and adds it to the earliest_col_date field in the urlinfo table, making it so you can sort your URLs by the earliest date of collection.

<p>
<br>
<a name="ideas"></a>
<hr width=25%>
<p>
<center><h2>Idea Organizer</h2>
<p>

<a href="ideas/update_ideas_tags_form.php" class="arlink">Update Ideas Tags</a> - This was made so the exported ideas I imported into my main database would have their tags made searchable by adding them to the tagmap and tags tables.  Hopefully not dangerous, but I wouldn't run it unless you really need to.  You shouldn't need to unless a) you either exported an ideas database that you just merged into another database, in which case you'll need to run this in order to have searchable tags on the imported items, or b) you're altering ABDesktop's code and messed up your database's tags somehow, or c) there are some tag glitches I still don't know about.
<p>
<a href="ideas/update_quote_longdesc_lengths_form.php" class="arlink">Update Quotelength and Longdesclength Fields</a>
<br>
<a name="files"></a>
<hr width=25%>
<p>
<center><h2>File Organizer</h2>
<p>

<a href="files/update_files_tags_form.php" class="arlink">Update Files Tags</a> - I made this to fix the tagmap of a database with glitchy tags.  Hopefully not dangerous, but I wouldn't run it unless you really need to.  You shouldn't need to unless you're altering ABDesktop's code and messed up your database's tags somehow, or unless there are some tag glitches I still don't know about.
<p>
<a href="files/copy_tmp_tns_to_prm_loc_form.php" class="arlink">Copy Temp Thumbnails to Permanent Location</a>
<br>
<a name="broken"></a>
<hr width=25%>
<p>
<center><h2>Broken Stuff</h2>
<p>
<a href="urls/export_urls_db_form.php" class="arlink">Export Links DB</a> - <b>Currently broken.</b>  I made this so I could merge a separate database into my main database. One problem with this script is, it doesn't yet do anything with the "urldatesofcollection" table, so, if you run it, you might want to keep the original copy of the databases you export with it until I write something that will do something with that table.  Also, you might want to refrain from exporting the same links more than once (at least if you care about the dates of collection table), since the script to handle dates of collection will probably rely on the "prevdb_url_id" field to work, which gets updated every time you export the links.  It also might be good to keep an original copy of the databases you export just in case there are some glitches.
<p>
<a href="ideas/export_ideas_db_form.php" class="arlink">Export Ideas DB</a> - <b>Currently broken.</b>  I made this so I could merge a separate database into my main database.  It might be good to keep a copy of the databases you export just in case there are some glitches.  Also, if you use the "Related IDs" data field at all, you might want to refrain from exporting ideas from one database, importing them into a new one, then exporting them again and reimporting them elsewhere, since the script to handle Related IDs will rely on the "prevdb_idea_id" field to work, which gets updated every time you export the ideas.
<p>

<?php AllOrganizerNavLinks(); 
